<script setup lang="ts">
import type { PublicationInput, Author } from "~/utils/types/publication";

const props = defineProps<{
  publication: PublicationInput;
}>();
const emit = defineEmits<{
  (e: "update:publication", v: PublicationInput): void;
}>();

const publication = computed({
  get: () => props.publication,
  set: (v: PublicationInput) => updatePublication(v),
});
const updatePublication = (updatedPublication: Partial<PublicationInput>) => {
  emit("update:publication", { ...publication.value, ...updatedPublication });
};
const { loading } = usePubmedPublication(publication);

const notOnPubMed = ref(false);
const showOtherFields = computed(
  () => !!publication.value.pmid || notOnPubMed.value,
);

const rules = {
  title: [(v: any) => !!v || "Title is required"],
  journal: [(v: any) => !!v || "Journal is required"],
  year: [(v: any) => !!v || "Year is required"],
  doi: [(v: any) => !!v || "DOI is required"],
  abstract: [(v: any) => !!v || "Abstract is required"],
  reference: [(v: any) => !!v || "Reference is required"],
};

const authorsRules = computed(() => {
  if (publication.value.authors.length === 0) {
    return [() => "Authors are required"];
  } else {
    return [];
  }
});

const pmidRules = computed(() => {
  if (notOnPubMed.value === false) {
    return [
      (v: any) =>
        !!v || "You must either enter a pmid or manually fill the details",
    ];
  } else {
    return [];
  }
});

const hints = {
  reference:
    "Complete reference in ANSI/NISO Z39.29-2005 (R2010) Bibliographic References standard (PubMed citation format)",
};

watch(
  () => publication.value.pmid,
  () => {
    if (publication.value.pmid !== "") {
      notOnPubMed.value = false;
    }
  },
);

watch(notOnPubMed, () => {
  if (notOnPubMed.value === true) {
    updatePublication({ pmid: "" });
  }
});
</script>

<template>
  <v-expand-transition>
    <div v-show="!notOnPubMed">
      <div class="pb-8">
        Enter the PubMed id of the publication. If valid, you will see other
        fields automatically filled out. You can also enter all the fields
        manually.
      </div>
      <InputLabel text="*PubMed ID:" />
      <v-text-field
        :model-value="publication.pmid"
        type="number"
        placeholder="e.g. 18586236"
        prefix="PMID:"
        :loading="!loading ? false : 'accent'"
        :rules="pmidRules"
        @update:modelValue="
          (pmid: PublicationInput['pmid']) => updatePublication({ pmid })
        "
      >
      </v-text-field>
    </div>
  </v-expand-transition>
  <v-expand-transition>
    <v-checkbox v-show="publication.pmid === ''" v-model="notOnPubMed">
      <template #label>
        <InputLabel text="My publication is not on PubMed" />
      </template>
    </v-checkbox>
  </v-expand-transition>
  <v-expand-transition>
    <div v-show="showOtherFields">
      <InputLabel text="*Authors:" />
      <ListInput
        :items="publication.authors"
        :rules="authorsRules"
        :new-item="() => ({ firstName: '', lastName: '' })"
        @update:items="
          (authors: PublicationInput['authors']) =>
            updatePublication({ authors })
        "
      >
        <template #default="{ item, idx, update: updateAuthor }">
          <PublicationAuthorInput
            :author="item"
            @update:author="(author: Author) => updateAuthor(idx, author)"
          />
        </template>
      </ListInput>
      <InputLabel text="*DOI:" />
      <v-text-field
        :model-value="publication.doi"
        :rules="rules.doi"
        @update:modelValue="
          (doi: PublicationInput['doi']) => updatePublication({ doi })
        "
      />
      <InputLabel text="*Title:" />
      <v-text-field
        :model-value="publication.title"
        :rules="rules.title"
        @update:modelValue="
          (title: PublicationInput['title']) => updatePublication({ title })
        "
      />
      <InputLabel text="*Journal:" />
      <v-text-field
        :model-value="publication.journal"
        :rules="rules.journal"
        @update:modelValue="
          (journal: PublicationInput['journal']) =>
            updatePublication({ journal })
        "
      />
      <InputLabel text="*Year:" />
      <v-text-field
        :model-value="publication.year"
        :rules="rules.year"
        type="number"
        @update:modelValue="
          (year: string) =>
            updatePublication({ year: year ? parseInt(year) : '' })
        "
      />
      <InputLabel text="*Abstract:" />
      <v-textarea
        :model-value="publication.abstract"
        :rules="rules.abstract"
        @update:modelValue="
          (abstract: PublicationInput['abstract']) =>
            updatePublication({ abstract })
        "
      />
      <InputLabel text="*Complete reference:" :help="hints.reference" />
      <v-textarea
        :model-value="publication.reference"
        :rules="rules.reference"
        @update:modelValue="
          (reference: PublicationInput['reference']) =>
            updatePublication({ reference })
        "
      />
    </div>
  </v-expand-transition>
</template>
